摘要:題目鏈接二分找結果,按左邊數來分如果改下,加入的,那就可以在時間內找到結果了
Kth Smallest Element in a BST
題目鏈接:https://leetcode.com/problems...
inorder traverse:
public class Solution { public int kthSmallest(TreeNode root, int k) { // morris: inorder traverse TreeNode cur = root, prev = null; int count = 0; while(cur != null) { // reach the end of left part if(cur.left == null) { if(++count == k) return cur.val; cur = cur.right; } else { prev = cur.left; // find the right most part while(prev.right != null && prev.right != cur) prev = prev.right; // reach the end of current right part if(prev.right == null) { prev.right = cur; cur = cur.left; } // recover the tree else { prev.right = null; if(++count == k) return cur.val; cur = cur.right; } } } return -1; } }
二分找結果,按左邊nodes數來分:
public class Solution { public int kthSmallest(TreeNode root, int k) { int left = getNum(root.left); if(left == k - 1) return root.val; else if(left < k - 1) return kthSmallest(root.right, k - left - 1); else return kthSmallest(root.left, k); } private int getNum(TreeNode node) { if(node == null) return 0; // divide and conquer return 1 + getNum(node.left) + getNum(node.right); } }
如果改下node,加入number of left的field,那就可以在O(h)時間內找到結果了:
/** * Definition for a binary tree node. * public class TreeNode { * int val; * TreeNode left; * TreeNode right; * int leftNum; * TreeNode(int x, int num) { val = x; leftNum = num; } * } */ public class Solution { public int kthSmallest(TreeNode root, int k) { int left = root.leftNum; if(left == k - 1) return root.val; else if(left < k - 1) return kthSmallest(root.right, k - left - 1); else return kthSmallest(root.left, k); } }
文章版權歸作者所有,未經允許請勿轉載,若此文章存在違規行為,您可以聯系管理員刪除。
轉載請注明本文地址:http://specialneedsforspecialkids.com/yun/66636.html
摘要:中序遍歷復雜度時間空間思路因為左節點小于根節點小于右節點,二叉搜索樹的一個特性就是中序遍歷的結果就是樹內節點從小到大順序輸出的結果。這里采用迭代形式,我們就可以在找到第小節點時馬上退出。這樣我們就可以用二叉樹搜索的方法來解決這個問題了。 Kth Smallest Element in a BST Given a binary search tree, write a function...
摘要:解題思路本題需要找的是第小的節點值,而二叉搜索樹的中序遍歷正好是數值從小到大排序的,那么這題就和中序遍歷一個情況。 Kth Smallest Element in a BSTGiven a binary search tree, write a function kthSmallest to find the kth smallest element in it. Note: You ...
摘要:題目意思就是要一個個的返回當前的最小值。所以解法自然就是。我們需要找出被打亂的點并返回正確結果。然后將兩個不正確的點記錄下來,最后回原來正確的值。如果是葉子節點,或者只有一個子樹。思想來自于的代碼實現。 跳過總結請點這里:https://segmentfault.com/a/11... BST最明顯的特點就是root.left.val < root.val < root.right.v...
摘要:先放一行,或一列把堆頂的最小元素取出來,取次,如果該有下一行下一列的,放入堆中最小的個元素已經在上面的循環被完了,下一個堆頂元素就是 Problem Given a n x n matrix where each of the rows and columns are sorted in ascending order, find the kth smallest element in...
Given a n x n matrix where each of the rows and columns are sorted in ascending order, find the kth smallest element in the matrix.Note that it is the kth smallest element in the sorted order, not the...
閱讀 1309·2021-11-15 11:37
閱讀 2564·2021-09-22 10:56
閱讀 3391·2021-09-06 15:11
閱讀 801·2021-08-31 09:45
閱讀 2897·2021-07-28 11:16
閱讀 1806·2019-08-30 15:44
閱讀 477·2019-08-30 13:22
閱讀 3344·2019-08-30 13:18